//Below is the 78 chars line!
//----------------------------------------------------------------------------
//Jason Winnebeck

#include "textbox.h"
#include <conio.h>

CTextBox::CTextBox() : box(1, 1, 5, 3), input(NULL), maxsize(0), currpos(0) {
}

CTextBox::CTextBox(int x, int y, int w, int h) : box(x, y, w, h), input(NULL), maxsize(0), currpos(0) {
}

CTextBox::~CTextBox() {
  if (input)
    delete[] input;
}

void CTextBox::SetName(const char* str) {
  box.SetName(str);
}

void CTextBox::Move(int x, int y, int w, int h) {
  box.Move(x, y, w, h);
}

void CTextBox::SetColors(int back, int fore, int text) {
  box.SetColors(back, fore, text);
}

void CTextBox::Draw() {
  box.Draw();
}

void CTextBox::Erase() {
  box.Erase();
}

void CTextBox::Reset() {
  box.Clear();
  currpos = 0;
}

void CTextBox::SetMax(int max) {
  maxsize = max;
  Reset();
  if (input)
    delete[] input;

  input = new char[maxsize + 1]; //Include space for NULL
}

bool CTextBox::Update() {
  if (kbhit()) {            //If any input waiting
    char ch = (char)getch();
    if (ch == 13)           //If user pressed RETURN
      return true;
    if (ch == 8) {          //If backspaced
      currpos--;
      if (currpos < 0) {
        currpos = 0;        //Hit the end
      } else {
        box << ch;          //Move back
        box << ' ';         //Erase character (BS doesn't erase by default)
        box << ch;          //Move back again
      }
    } else {                //Normal character
      currpos++;
      if (currpos >= maxsize) {
        currpos = maxsize-1;//Clip off at end
      } else {
        box << ch;          //Display input
        input[currpos-1] = ch;//update input string
      }
    }
  }
  return false;
}

char* CTextBox::GetInput() {
  input[currpos] = '\0';    //properly terminate string
  return input;
}
