//Below is the 78 chars line!
//----------------------------------------------------------------------------
//Jason Winnebeck

#include <conio.h>
#include <string.h>
#include "window.h"
#include <stdio.h>
#include <stdlib.h>
#include <pc.h>

CWindow::CWindow() : x(0), y(0), w(5), h(5), posx(1), posy(1), back(0), fore(7), text(7) {
  title = new char[2]; //Create a valid string
  title[0] = ' ';
  title[1] = '\0';
}

CWindow::CWindow(int x2, int y2, int w2, int h2) : x(x2), y(y2), w(w2-1), h(h2-1), posx(1), posy(1), back(0), fore(7), text(7) {
  title = new char[2]; //Create a valid string
  title[0] = ' ';
  title[1] = '\0';
}

CWindow::~CWindow() {
  if (title)
    delete[] title;
}

void CWindow::Move(int x2, int y2, int w2, int h2) {
  x = x2; y = y2; w = w2-1; h = h2-1; //Why subract one?  Because a win at
                                      // 1,1 that's 80 wide SHOULD only go to
                                      // 80,1, which is 1+79!
}

void CWindow::SetName(const char* title2) {
  if (title)
    delete[] title;

  int newstrlen = strlen(title2) + 1; //Don't forget NULL!
  title = new char[newstrlen];
  strcpy(title, title2);
}

void CWindow::SetColors(int back2, int fore2, int text2) {
  back = back2;
  fore = fore2;
  text = text2;
}

void CWindow::Clear() {
  posx = posy = 1;
  window(x+1, y+1, x+w-1, y+h-1);
  clrscr();
}

void CWindow::Draw() {
  textattr((back << 4) | fore);   //Setup window colors
  window(1, 1, 80, 25);           //Global positioning

  //Window top
  char line[81];                  //Temp output buf
  int curr;                       //current position in line
  curr = sprintf(line, "͵ %s ", title);
  int rest = w - (4 + strlen(title) + 1) - 1;
    //Total width minus title and sides and upper right corner
  for (int c=0; c<rest; c++)
    line[curr+c] = '';
  line[rest+curr] = '';
  line[rest+curr+1] = '\0';
  ScreenPutString(line, (back << 4) | fore, x-1, y-1);

  //Middle window area (DO NOT CLEAR)
  for (int c=y+1; c<y+h; c++) {
    gotoxy(x, c);
    putch('');
    gotoxy(x+w, c);
    putch('');
  }

  //Bottom line
  line[0] = '';
  for (int c=1; c<w; c++)
    line[c] = '';
  line[w] =  '';
  line[w+1] = '\0';
  ScreenPutString(line, (back << 4) | fore, x-1, y+h-1);
}

void CWindow::Erase() {
  window(x, y, x+w, y+h);
  textattr(7);
  clrscr();
}

CWindow& CWindow::operator << (char ch) {
  SetupWin();

  putch(ch);
  if (ch == '\n')
    gotoxy(1, wherey());

  SavePos();
  return *this;
}

int CWindow::FindNewlines(char *str) {
  //The function is interesting. It replaces the newlines with NULLs so a
  // cputs loop can CORRECTLY implement newline chars, and linefeeding,
  // rather than just dropping down.
  int l = strlen(str);
  for (int c=0; c<l; c++)
    if (str[c] == '\n') {
      str[c] = '\0';
    }
  return l;  //Return the length so we know when to stop
}

CWindow& CWindow::operator << (const char* str) {
  SetupWin();

  char* temp = new char[strlen(str)+1];
  strcpy(temp, str);

  int l = FindNewlines(temp);     //Replace with NULLs, get len
  int disp = 0;                   //Amount displayed so far

  while (disp < l) {
    cputs(&temp[disp]);           //Output text
    disp += strlen(&temp[disp])+1;//Update pos, skip over that NULL
    if (disp <= l) {              //if not at end do a proper linefeed
      putch('\n');                //Advance a line, scrolling if needed
      gotoxy(1, wherey());        //Proper linefeed
    }
  }

  SavePos();
  return *this;
}

CWindow& CWindow::operator << (int x) {
  SetupWin();

  char output[33];
  itoa(x, output, 10);
  cputs(output);

  SavePos();
  return *this;
}

CWindow& CWindow::operator << (double x) {
  SetupWin();

  char output[64];
  sprintf(output, "%f", x);
  cputs(output);

  SavePos();
  return *this;
}

void CWindow::operator << (ostrstream* &out) {
  SetupWin();

  *out << '\0';                   //NULL terminate buffer
  char* str = out->str();
  int l = FindNewlines(str);      //Replace with NULLs, get len
  int disp = 0;                   //Amount displayed so far

  while (disp < l) {
    cputs(&str[disp]);            //Output text
    disp += strlen(&str[disp])+1; //Update pos, skip over that NULL
    if (disp <= l) {              //if not at end do a proper linefeed
      putch('\n');                //Advance a line, scrolling if needed
      gotoxy(1, wherey());        //Proper linefeed
    }
  }

  SavePos();

  delete out;                     //Erase out output string
  out = NULL;
}

void CWindow::SetupWin() {
  window(x+1, y+1, x+w-1, y+h-1); //Setup window
  textattr((back << 4) | text);   //Set colors
  gotoxy(posx, posy);             //Restore position
}

void CWindow::SavePos() {
  posx = wherex();                //Save position
  posy = wherey();
}

