//Below is the 78 chars line!
//----------------------------------------------------------------------------
//Jason Winnebeck

#ifndef _WINDOW_H_
#define _WINDOW_H_

#include <strstream.h>

class CWindow {
public:
  CWindow();
  CWindow(int x2, int y2, int w2, int h2);
  ~CWindow();

  void Move(int x2, int y2, int w2, int h2); //Simply assign vars to window
  void SetName(const char* title2);          //COPIES data from title2
  void SetColors(int back2, int fore2, int text2);//Sets colors  

  void Clear(); //Clears the window
  void Draw();  //Draws the window frame (doesn't HAVE to clear inside)
  void Erase(); //Completely clears the window from the screen

  //Operators as an attempt to direct input
  CWindow& operator << (char ch);
  CWindow& operator << (const char* str);
  CWindow& operator << (int x);
  CWindow& operator << (double x);

  void operator << (ostrstream* &out);//Displays text in window
private:
  void SetupWin();      //For drawing
  void SavePos();       //Saves text position
  int  FindNewlines(char* str);//Allows for \n in strings

  char* title;          //Window title
  int x, y, w, h;       //Upper left and width/height
  int posx, posy;       //Current curson position
  int back, fore, text; //Text colors
};

#endif
